/****************************************************************************
Program    : Becho 
Version    : 1.00.A
Programmer : Binny V Abraham
E-Mail     : binnyva@rediffmail.com
Website    : http://www.geocities.com/binnyva
C++ Special: http://www.geocities.com/binnyva/code/cpp/

Use
---
A replacement for DOS' `echo` command. See help for more info.

Special
-------
This is a part of the Batch Toolkit by Binny's softwares. To find out more,
go to http://www.geocities.com/binnyva. Programs in Batch Toolkit -
Becho, Getline, Message, Select, Tnd. Made for use in Batch files.

Started and ended on 13th June 2004

License
-------
You can use this program, modify it, distribute it, make money from it or
any thing by it. But please give credit where credit is due. Just leave
this notice as it is, however you use it.

Disclamer
---------
If any thing happens to your computer by using my program, it is NOT my porblem. 
It will be your own fault.

If you want more info, contact me at binnyva@rediffmail.com.
****************************************************************************/
#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <iostream.h>

//Global variables.
char version[]="1.00.A";

/****************************************************************************
Function : slasher()
Use      : Does inline formating. That is change '\n' to new line, '\t' to
	   Tab etc. Occurs three times in the program
Arguments: char *word
Returns  : int flag
****************************************************************************/
int slasher(char *word)
 {
 char c;
 int flag=0;
 for(int j=0;j<strlen(word);j++)
  {
  if(word[j]=='\\'&&!flag) //If there is a slash in the input,
   {
   j=-1;  // initiate the loop again so that even after j++ it will be 0,
   flag=1;//and enter into complicated outputing
   }
  else if(flag)
   {
   if(word[j]=='\\') //If there is a slash, do the thing that follows it
    {
    j++;
    c=word[j];
    if(c=='n') cout<<"\n";     //New Line
    else if(c=='a') cout<<"\a";//Audiable Bell
    else if(c=='t') cout<<"\t";//Tab Charector
    else if(c=='b') cout<<"\b";//Backspace
    else cout<<"\\";
    }
   else putch(word[j]);
   }
  }
 return flag;
 }

/****************************************************************************
Function : MAIN()
/****************************************************************************/
void main(int argc,char *argv[])
 {
 int debug=0;
 int flag=0;

 //Default Colours
 int fore_color=LIGHTGRAY,back_color=BLACK;
 //Extendent Formating
 int ext = 0;
 if(!strcmpi(argv[1],"-x")) ext=1;

 if(debug) clrscr();

 for(int i=1;i<argc;i++)
  {
  if(argv[i][0]=='-')
   {
   //Fore Colour Selector
   if(argv[i][1]=='F'||argv[i][1]=='f')
    {
    if(!strcmpi(argv[i],"-fblack")||!strcmpi(argv[i],"-f0")) fore_color=BLACK;
    else if(!strcmpi(argv[i],"-fblue")||!strcmpi(argv[i],"-f1")) fore_color=BLUE;
    else if(!strcmpi(argv[i],"-fgreen")||!strcmpi(argv[i],"-f2")) fore_color=GREEN;
    else if(!strcmpi(argv[i],"-fcyan")||!strcmpi(argv[i],"-f3")) fore_color=CYAN;
    else if(!strcmpi(argv[i],"-fred")||!strcmpi(argv[i],"-f4")) fore_color=RED;
    else if(!strcmpi(argv[i],"-fmagenta")||!strcmpi(argv[i],"-f5")) fore_color=MAGENTA;
    else if(!strcmpi(argv[i],"-fbrown")||!strcmpi(argv[i],"-f6")) fore_color=BROWN;
    else if(!strcmpi(argv[i],"-flightgray")||!strcmpi(argv[i],"-f7")) fore_color=LIGHTGRAY;
    else if(!strcmpi(argv[i],"-fdarkgray")||!strcmpi(argv[i],"-f8")) fore_color=DARKGRAY;
    else if(!strcmpi(argv[i],"-flightblue")||!strcmpi(argv[i],"-f9")) fore_color=LIGHTBLUE;
    else if(!strcmpi(argv[i],"-flightgreen")||!strcmpi(argv[i],"-f10")) fore_color=LIGHTGREEN;
    else if(!strcmpi(argv[i],"-flightcyan")||!strcmpi(argv[i],"-f11")) fore_color=LIGHTCYAN;
    else if(!strcmpi(argv[i],"-flightred")||!strcmpi(argv[i],"-f12")) fore_color=LIGHTRED;
    else if(!strcmpi(argv[i],"-fightmagenta")||!strcmpi(argv[i],"-f13")) fore_color=LIGHTMAGENTA;
    else if(!strcmpi(argv[i],"-fyellow")||!strcmpi(argv[i],"-f14")) fore_color=YELLOW;
    else if(!strcmpi(argv[i],"-fwhite")||!strcmpi(argv[i],"-f15")) fore_color=WHITE;
    }
   //Background Colour Selector
   else if(argv[i][1]=='B'||argv[i][1]=='b')
    {
    if(!strcmpi(argv[i],"-bblack")||!strcmpi(argv[i],"-b0")) back_color=BLACK;
    else if(!strcmpi(argv[i],"-bblue")||!strcmpi(argv[i],"-b1")) back_color=BLUE;
    else if(!strcmpi(argv[i],"-bgreen")||!strcmpi(argv[i],"-b2")) back_color=GREEN;
    else if(!strcmpi(argv[i],"-bcyan")||!strcmpi(argv[i],"-b3")) back_color=CYAN;
    else if(!strcmpi(argv[i],"-bred")||!strcmpi(argv[i],"-b4")) back_color=RED;
    else if(!strcmpi(argv[i],"-bmagenta")||!strcmpi(argv[i],"-b5")) back_color=MAGENTA;
    else if(!strcmpi(argv[i],"-bbrown")||!strcmpi(argv[i],"-b6")) back_color=BROWN;
    else if(!strcmpi(argv[i],"-blightgray")||!strcmpi(argv[i],"-b7")) back_color=LIGHTGRAY;
    }
   //If Extended Formating is there
   if(ext)
    {
    //The Blink Option
    if(!strcmpi(argv[i],"-blink")) fore_color=fore_color+BLINK;       //Enable Blink
    else if(!strcmpi(argv[i],"-noblink")) fore_color=fore_color-BLINK;//Disable Blink
    }
   }
  //Command line argument don't start with a '-'
  else
   {
   //If Extended Formating is there
   if(ext)
    {
    textcolor(fore_color);
    textbackground(back_color);
    if(i!=2) cputs(" "); //This is given so that the last space is avoided
    flag = slasher(&argv[i][0]); //Call function to do inline formating
    if(!flag) cputs(argv[i]);
    }
   }
  }

//When Extented formating is not there
if(!ext)
 {
 //Find Non-Color options
 for(i=1;i<argc;i++)
  {
  //The Blink Option
  if(!strcmpi(argv[i],"-blink")) fore_color+=BLINK;
  //Debug
  else if(!strcmpi(argv[i],"-debug")) debug=1;
  }

 //Print what is to be printed
 for(i=1;i<argc;i++)
  {
  if(argv[i][0]!='-')
   {
   if(fore_color!=7||back_color!=0)//If formating is done
    {
    textcolor(fore_color);        //Give the needed colours
    textbackground(back_color);   //

    if(i!=1) cputs(" "); //This is given so that the last space is avoided
    flag = slasher(&argv[i][0]); //Call the slasher funtion to do inline formating
    if(!flag) cputs(argv[i]); //If there was no complicated outputing, display the output as a single unit.
    }
   else //If formatting is not done, the output will be as 'cout' because only 'cout' can be written to a file by dos command. For eg. `becho http://www.geocities.com/binnyva > Site.txt`
    {
    if(i!=1) cout<<" ";
    flag = slasher(&argv[i][0]);
    if(!flag) cout<<argv[i];
    }
   }
  }
 }

 //Help runs from command line
 if(!strcmpi(argv[1],"-?")||!strcmpi(argv[1],"/?")||!strcmpi(argv[1],"-h")||!strcmpi(argv[1],"-help")||!strcmpi(argv[1],"--help"))
  {
  cout<<"Becho V "<<version<<" from Binny's Softwares\n"
      <<"Online : http://www.geocities.com/binnyva\nE-Mail : binnyva@rediffmail.com\n"
      <<"Becho is a replacement for the `echo` command of DOS. Becho is a very powerful program and with proper use, one can work wonders with it.\n"
      <<"\nCommand Line Options\n--------------------\n"
      <<"-Fxxxxxxx \t Font Color. Replace <xxxxxxx> with color name.\n"
      <<"-Bxxxxxxx \t Background Colour. Replace <xxxxxxx> with color name.\n"
      <<"-blink    \t Enables Blinking mode.\n"
      <<"-X        \t Enables eXtended mode. In this mode you can give diffrent\n"
      <<"\t\t   colours for the same line. An example is given below.\n"
      <<"\t\t becho -x -Fblack -Blightgray -blink Website\n" //The Full command : "becho -x -Fblack -Blightgray -blink Website -noblink -Bblack -Fwhite : -Bcyan -Fred http://www.geocities.com/ -Fblue \bbinnyva"
      <<"\t\t   -blink website -noblink -Bblack -Fwhite\n"
      <<"\t\t   -noblink -Bblack -Fwhite : -Bcyan -Fred\n"
      <<"\t\t   http://www.geocities.com/ -Fblue \bbinnyva\n"
      <<"\t\t Note : The whole command must be given in one line.\n"
      <<"\nColours\n-------\n"
	<<"Colour Name   Code  Background  Example\n"
	<<"-----------------------------------------";
  cout<<"\n BLACK         0    Yes         ";textbackground(WHITE);textcolor(BLACK);cputs("-Fblack"); textbackground(BLACK);
  cout<<"\n BLUE          1    Yes         ";textcolor(BLUE);cputs("-F1");
  cout<<"\n GREEN         2    Yes         ";textcolor(GREEN);cputs("-fGREEN");
  cout<<"\n CYAN          3    Yes         ";textbackground(CYAN);cputs("-Bcyan");
  cout<<"\n RED           4    Yes         ";textbackground(RED);cputs("-b4"); textbackground(BLACK);
  cout<<"\n MAGENTA       5    Yes         ";textcolor(MAGENTA);cputs("-fMagenta"); textcolor(WHITE);
  cout<<"\n BROWN         6    Yes         ";textbackground(BROWN);cputs("-Bbrown");
  cout<<"\n LIGHTGRAY     7    Yes         ";textbackground(LIGHTGRAY);cputs("-B7");textbackground(BLACK);
  cout<<"\n DARKGRAY      8    No          ";textcolor(DARKGRAY);cputs("-FDARKGRAY");
  cout<<"\n LIGHTBLUE     9    No          ";textcolor(LIGHTBLUE);cputs("-FLIGHTBLUE");
  cout<<"\n LIGHTGREEN   10    No          ";textcolor(LIGHTGREEN);cputs("-FLIGHTGREEN");
  cout<<"\n LIGHTCYAN    11    No          ";textcolor(LIGHTCYAN);cputs("-F11");
  cout<<"\n LIGHTRED     12    No          ";textcolor(LIGHTRED);cputs("-F12");
  cout<<"\n LIGHTMAGENTA 13    No          ";textcolor(LIGHTMAGENTA);cputs("-f13");
  cout<<"\n YELLOW       14    No          ";textcolor(YELLOW);cputs("-F14");
  cout<<"\n WHITE        15    No          ";textcolor(WHITE);cputs("-FWHITE");textbackground(BLACK);textcolor(LIGHTGRAY);
  cout<<"\n\tYou can use the number insted of typing in the full name of the colour, as shown in the examples\n"
      <<"\nInline Formating\n----------------\n"
      <<"You can use the codes given below in the strings that you give to get untypeable charectors like New Line, Audiable Bell etc.\n"
       <<"Code  Does this\n"
       <<"\n"
      <<" \\a   Sounds a bell\n"
      <<" \\b   Backspace\n"
      <<" \\n   New line\n"
      <<" \\t   Tab Charector\n"
     <<" \\\\   Prints a \\\n";
  }
 if(argc<2)
  {
  cout<<"Becho V"<<version<<" from Binny's Softwares\n"
      <<"No arguments specifed.\n"
      <<"USAGE : becho [-x] STRING [-F<color_name>] [-B<color_name>] [-BLINK]\n"
      <<"Type with 'becho -?' for help";
  }

 if(debug) getch();
 }

/****************************************************************************
TO DO
-----
In extended formating, the use of back ground colouring causes the space
before the word to be coloured as well. Must avoid that.
****************************************************************************/
